/*----------------------------------------------------------------------
	This is part of the PureLS Source code.

	Copyright (C) 2000-2003 The PureLS Development Team

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
	USA
----------------------------------------------------------------------*/


/*----------------------------------------------------------------------
 Lets just make sure we aren't depending on IE
----------------------------------------------------------------------*/
#define _WIN32_IE 0x0000


/*---System Includes--------------------------------------------------*/
#include <tchar.h>
#include <windows.h>
#include <stdio.h>
/*---Shell Includes---------------------------------------------------*/
#include "../sdk/include/plsdefs.h"
#include "plsapi.h"
/*--------------------------------------------------------------------*/

FILE* WINAPI PL_fOpen ( LPCTSTR fPath )
{
	FILE* f = NULL;
	if (fPath != NULL && *fPath != 0)
	{
		f = _tfopen(fPath, _T("r"));
		if (f != NULL)
			fseek(f, 0, SEEK_SET);
	}
	return f;
}

void WINAPI PL_fClose ( FILE* f )
{
	if (f != NULL)
		fclose(f);
	return;
}

LONG WINAPI PL_fSetPos ( FILE* f, LONG newPos, BOOL useCurPos )
{
	return ( (f != NULL && !fseek( f, newPos, useCurPos ? SEEK_CUR:SEEK_SET )) ?  ftell( f ):-1L );
}

LONG WINAPI PL_fFindSetPos ( FILE* f, LPTSTR srcStr )
{
	PL_fGetLine( f, 0, NULL, srcStr, 0 );
	return PL_fGetPos ( f );
}

LONG WINAPI PL_fGetPos ( FILE* f )
{
	return ( f != NULL ? ftell( f ):-1L );
}

BOOL WINAPI PL_fGetNextLine ( FILE* f, LONG fEndPos, LPTSTR buffer, size_t maxlen )
{
	_TCHAR tmpBuf[PLS_MAX_SIZE] = {0};
	while (f && !ferror(f) && !feof(f) && (fEndPos > 0 ? PL_fGetPos(f) <= fEndPos:1))
	{
		if (!_fgetts(tmpBuf, PLS_MAX_SIZE, f))
			continue;
		if (PL_StripWS(tmpBuf) && *tmpBuf != _T(';'))
		{
			if (buffer != NULL && maxlen > 0)
			{
				_tcsncpy(buffer, tmpBuf, maxlen);
				buffer[maxlen-1] = 0;
			}
			return TRUE;
		}
	}
	return FALSE;
}

BOOL WINAPI PL_fGetLine ( FILE* f, LONG fEndPos, LPTSTR buffer, LPCTSTR srcStr, size_t maxlen )
{
	_TCHAR tmpBuf[PLS_MAX_SIZE] = {0};
	while (f && !ferror(f) && !feof(f) && (fEndPos > 0 ? PL_fGetPos(f) <= fEndPos:1))
	{
		if (!_fgetts(tmpBuf, PLS_MAX_SIZE, f))
			continue;
		if (PL_StripWS(tmpBuf) && *tmpBuf != _T(';'))
		{
			if (srcStr == NULL || *srcStr == 0 || 0 == _tcsnicmp(tmpBuf, srcStr, _tcslen(srcStr)))
			{
				if (buffer != NULL && maxlen > 0)
				{
					_tcsncpy(buffer, tmpBuf, maxlen);
					buffer[maxlen-1] = 0;
				}
				return TRUE;
			}
		}
	}
	return FALSE;
}


/*----------------------------------------------------------------------
 END OF FILE
----------------------------------------------------------------------*/
