/*----------------------------------------------------------------------
	This is part of the PureLS Source code.

	Copyright (C) 2000-2003 The PureLS Development Team

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
	USA
----------------------------------------------------------------------*/


/*----------------------------------------------------------------------
 Lets just make sure we aren't depending on IE
----------------------------------------------------------------------*/
#define _WIN32_IE 0x0000


/*---System Includes--------------------------------------------------*/
#include <tchar.h>
#include <windows.h>
#include <stdio.h>
/*---Shell Includes---------------------------------------------------*/
#include "../sdk/include/plsdefs.h"
#include "plsapi.h"
/*--------------------------------------------------------------------*/

BOOL WINAPI PL_TransparentStretchBlt (
	HDC hdcDest,
	INT nXOriginDest, INT nYOriginDest,
	INT nWidthDest, INT nHeightDest,
	HDC hdcSrc,
	INT nXOriginSrc, INT nYOriginSrc,
	INT nWidthSrc, INT nHeightSrc,
	UINT crTransparent
)
{
	HDC hMaskDC;
	HDC hOverlayDC;
	HDC hCompositeDC;

	HBITMAP hMaskBmp;
	HBITMAP hOverlayBmp;
	HBITMAP hCompositeBmp;

	HBITMAP hOldMaskBmp;
	HBITMAP hOldOverlayBmp;
	HBITMAP hOldCompositeBmp;

	COLORREF crOld;

	HPALETTE hPal;

	BOOL Result;


	Result = FALSE;

	hMaskDC = CreateCompatibleDC(hdcDest);
	hOverlayDC = CreateCompatibleDC(hdcDest);
	hCompositeDC = CreateCompatibleDC(hdcDest);

	SetStretchBltMode(hMaskDC, COLORONCOLOR);

	hMaskBmp = CreateBitmap(nWidthDest, nHeightDest, 1, 1, NULL);
	hOverlayBmp = CreateCompatibleBitmap(hdcDest, nWidthDest, nHeightDest);
	hCompositeBmp = CreateCompatibleBitmap(hdcDest, nWidthDest, nHeightDest);

	hOldMaskBmp = (HBITMAP)(SelectObject(hMaskDC, hMaskBmp));
	hOldOverlayBmp = (HBITMAP)(SelectObject(hOverlayDC, hOverlayBmp));
	hOldCompositeBmp = (HBITMAP)(SelectObject(hCompositeDC, hCompositeBmp));

	crOld = SetBkColor(hdcSrc, crTransparent);

	SetStretchBltMode(hMaskDC, COLORONCOLOR);
	Result = StretchBlt(hMaskDC, 0, 0, nWidthDest, nHeightDest, hdcSrc, nXOriginSrc, nYOriginSrc, nWidthSrc, nHeightSrc, NOTSRCCOPY);
	SetBkColor(hdcSrc, crOld);

	Result &= BitBlt(hOverlayDC, 0, 0, nWidthDest, nHeightDest, hMaskDC, 0, 0, NOTSRCCOPY);
	Result &= BitBlt(hOverlayDC, 0, 0, nWidthDest, nHeightDest, hdcDest, nXOriginDest, nYOriginDest, SRCAND);
	Result &= BitBlt(hCompositeDC, 0, 0, nWidthDest, nHeightDest, hMaskDC, 0, 0, SRCCOPY);

	DeleteObject(SelectObject(hMaskDC, hOldMaskBmp));
	DeleteDC(hMaskDC);

	hPal = (HPALETTE)(GetCurrentObject(hdcDest, OBJ_PAL));
	if (hPal)
	{
		hPal = SelectPalette(hCompositeDC, hPal, FALSE);
		RealizePalette(hCompositeDC);
	}

	SetStretchBltMode(hCompositeDC, COLORONCOLOR);

	Result &= StretchBlt(hCompositeDC, 0, 0, nWidthDest, nHeightDest, hdcSrc, nXOriginSrc, nYOriginSrc, nWidthSrc, nHeightSrc, SRCAND);
	Result &= BitBlt(hCompositeDC, 0, 0, nWidthDest, nHeightDest, hOverlayDC, 0, 0, SRCPAINT);

	DeleteObject(SelectObject(hOverlayDC, hOldOverlayBmp));
	DeleteDC(hOverlayDC);

	Result &= BitBlt(hdcDest, nXOriginDest, nYOriginDest, nWidthDest, nHeightDest, hCompositeDC, 0, 0, SRCCOPY);

	SelectPalette(hCompositeDC, hPal, FALSE);
	DeleteObject(SelectObject(hCompositeDC, hOldCompositeBmp));
	DeleteDC(hCompositeDC);

	return Result;
}


/*----------------------------------------------------------------------
 END OF FILE
----------------------------------------------------------------------*/
