/*------------------------------------------------------------------------------
	This is part of the PureLS Source code.

	Copyright (C) 2000-2003 The PureLS Development Team

	This program is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2 of the License, or (at your option)
	any later version.

	This program is distributed in the hope that it will be useful, but WITHOUT
	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
	FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
	more details.

	You should have received a copy of the GNU General Public License along with
	this program; if not, write to the Free Software Foundation, Inc.,
	59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
------------------------------------------------------------------------------*/
#ifndef __COMMON_H
#define __COMMON_H

/*----------------------------------------------------------------------------*/

#define dSTARTUP_NORMAL  (0)
#define dSTARTUP_DISABLE (1)
#define dSTARTUP_FORCE   (2)

#define dINSTANCE_NORMAL  (0)
#define dINSTANCE_SINGLE  (1)
#define dINSTANCE_MULTI   (2)


/*----------------------------------------------------------------------------*/

#define PLSTEXT_INSTANCE_CAPTION \
	_T("PureLS - Continue Loading?")

#define PLSTEXT_INSTANCE_MSG \
	_T("Another instance of your shell is already open.\r\nRunning a new instance may cause conflicts.\r\n\r\nTo disable this warning use the command line switch: -m[0/1]")

/*----------------------------------------------------------------------------*/

#define PLSTEXT_EVENTHANDLER_CAPTION \
	_T("MsgWaitForMultipleObjects")

#define PLSTEXT_EVENTHANDLER_MSG \
	_T("%s failed: GetLastError returned %u\n")

/*----------------------------------------------------------------------------*/

#define PLSTEXT_LSCRASHED_CAPTION \
	_T("PureLS - Error!")

#define PLSTEXT_LSCRASHED_MSG \
	_T("The Litestep Module System crashed.\r\nThe shell will now exit. Sorry.")

/*----------------------------------------------------------------------------*/

#define PLSTEXT_TERMINATETHREAD_CAPTION \
	_T("PureLS - Notice!")

#define PLSTEXT_TERMINATETHREAD_STARTUP_MSG \
	_T("The Startup thread is being forcefully terminated.\n\nPlease notify the PureLS dev-team of this occurrence!")

#define PLSTEXT_TERMINATETHREAD_SERVICE_MSG \
	_T("The Service thread is being forcefully terminated.\n\nPlease notify the PureLS dev-team of this occurrence!")

#define PLSTEXT_TERMINATETHREAD_LITESTEP_MSG \
	_T("The Litestep Module System thread is being forcefully terminated.\n\nPlease notify the PureLS dev-team of this occurrence!")

/*----------------------------------------------------------------------------*/

#define PLSTEXT_EXIT_CAPTION \
	_T("PureLS - Error!")

#define PLSTEXT_EXIT_UNICODE_MSG \
	_T("This is a UNICODE build meant for Windows NT platforms.\r\nThe shell will now exit. Sorry.")

#define PLSTEXT_EXIT_PATH_MSG \
	_T("There were problems allocating basic resources for the shell.\r\nThe shell will now exit. Sorry.")

/*----------------------------------------------------------------------------*/

#define ErrorMessageBox(x,y,z) \
	MessageBox( \
		 NULL \
		,x \
		,y \
		,z|MB_ICONERROR|MB_SYSTEMMODAL \
	)

#define WarningMessageBox(x, y, z) \
	MessageBox( \
		 NULL \
		,x \
		,y \
		,z|MB_ICONWARNING|MB_SYSTEMMODAL \
	)

/*----------------------------------------------------------------------------*/

#endif /* __COMMON_H */

/*--------End Of File---------------------------------------------------------*/
