/*------------------------------------------------------------------------------
	This is part of the PureLS Source code.

	Copyright (C) 2000-2003 The PureLS Development Team

	This program is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2 of the License, or (at your option)
	any later version.

	This program is distributed in the hope that it will be useful, but WITHOUT
	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
	FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
	more details.

	You should have received a copy of the GNU General Public License along with
	this program; if not, write to the Free Software Foundation, Inc.,
	59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
------------------------------------------------------------------------------*/
#ifndef __SERVICES_H
#define __SERVICES_H

#include "common.h"

/*----------------------------------------------------------------------------*/

extern HANDLE g_hLitestepThread;
extern HANDLE g_hServicesThread;
extern HANDLE g_hStartupThread;

extern HANDLE g_hShellReadyEvent;

extern DWORD g_dwStartup;

extern BOOL g_bNT5Tray;
extern BOOL g_bServices;

extern LPTSTR g_pszAppPath;
extern LPTSTR g_pszCfgFile;

#ifdef PLS_EXCEPTION_HANDLER
extern VOID PLS_ExceptionHandlerPush(PLS_ExceptionHandler Handler);
extern VOID PLS_ExceptionHandlerPop(VOID);
extern BOOL PLS_LoadExceptionHandler(VOID);
extern VOID PLS_UnloadExceptionHandler(VOID);
#endif /* PLS_EXCEPTION_HANDLER */

/* Startup Service Items */
typedef UINT (WINAPI *SS_RunStartup)( HANDLE );

/* Shell Service Items */
typedef INT (WINAPI *SS_MainFunc)( BOOL, HANDLE );

/* Config Service Items */
typedef BOOL (WINAPI *SC_FillBuffer)( LPCTSTR, LPCTSTR );
typedef BOOL (WINAPI *SC_FreeBuffer)( VOID );

/* LSAPI Entry point */
typedef INT (WINAPI *LS_LitestepMainFunc)( LPCTSTR, HANDLE );


/*----------------------------------------------------------------------------*/

#endif /* __SERVICES_H */

/*--------End Of File---------------------------------------------------------*/
