/*----------------------------------------------------------------------
	This is part of the PureLS Source code.

	Copyright (C) 2000-2002 The PureLS Development Team

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
	USA
----------------------------------------------------------------------*/


#ifndef _INC_CONFIG
#define _INC_CONFIG

#ifndef SHELLCFG
#define SHELLCFG __declspec( dllimport )
#endif

#ifdef __cplusplus
	extern "C" {
#endif

	SHELLCFG BOOL WINAPI SH_CFG_IsBufferOpen ( VOID );
	SHELLCFG VOID WINAPI SH_CFG_FreeBuffer ( VOID );
	SHELLCFG BOOL WINAPI SH_CFG_FillBuffer ( LPCTSTR, LPCTSTR );
	SHELLCFG BOOL WINAPI SH_CFG_RefillBuffer( VOID );

	SHELLCFG BOOL WINAPI SH_CFG_GetFileFolder ( UINT*, LPTSTR );
	SHELLCFG BOOL WINAPI SH_CFG_GetModFolder ( UINT*, LPTSTR );
	SHELLCFG BOOL WINAPI SH_CFG_GetConfigFile ( UINT*, LPTSTR );
	SHELLCFG BOOL WINAPI SH_CFG_GetLoadModule ( UINT*, LPTSTR );
	SHELLCFG BOOL WINAPI SH_CFG_GetRunItem ( UINT*, LPTSTR );
	SHELLCFG BOOL WINAPI SH_CFG_GetRunFolder ( UINT*, LPTSTR );

	SHELLCFG BOOL WINAPI SH_CFG_FindLine( UINT*, LPCTSTR );
	SHELLCFG BOOL WINAPI SH_CFG_GetLine ( UINT*, LPTSTR, LPCTSTR, size_t, BOOL );
	SHELLCFG BOOL WINAPI SH_CFG_GetParam ( UINT*, LPTSTR, LPCTSTR, size_t, BOOL );

	SHELLCFG BOOL WINAPI SH_CFG_GetString ( LPTSTR, LPCTSTR, LPCTSTR, size_t );
	SHELLCFG BOOL WINAPI SH_CFG_GetBool ( LPCTSTR );
	SHELLCFG INT WINAPI SH_CFG_GetInt ( LPCTSTR, INT );
	SHELLCFG COLORREF WINAPI SH_CFG_GetColor ( LPCTSTR, COLORREF );

	SHELLCFG LPTSTR WINAPI SH_CFG_ExpandBuffer ( LPTSTR, LPCTSTR, size_t );
	SHELLCFG VOID WINAPI SH_CFG_RegisterVar ( LPCTSTR );
	SHELLCFG VOID WINAPI SH_CFG_UnregisterVar ( LPCTSTR );
	SHELLCFG BOOL WINAPI SH_CFG_GetVar ( LPTSTR, LPCTSTR, size_t );

#ifdef __cplusplus
	};
#endif

#undef SHELLCFG

#endif /* _INC_CONFIG */
