/*----------------------------------------------------------------------
	This is part of the PureLS Source code.

	Copyright (C) 2000-2002 The PureLS Development Team

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
	USA
----------------------------------------------------------------------*/


#ifndef _INC_LSMSGS
#define _INC_LSMSGS


/* message defines */
#ifdef /**/ DEFINEUNSUPPORTEDLSMSGS
#define LM_SHUTDOWN                    8889
#define LM_REPAINT                     8890
#define LM_BRINGTOFRONT                8891
#define LM_SAVEDATA                    8892
#define LM_RESTOREDATA                 8893

#define LM_POPUP                       9182
#define LM_HIDEPOPUP                   9183
#define LM_FIRSTDESKTOPPAINT           9184
#define LM_LSSELECT                    9185
#define LM_SETTASKBARONTOP             9186

#define LM_SAVESYSTRAY                 9210
#define LM_RESTORESYSTRAY              9211
#define LM_CHECKFORAPPBAR              9212
#define LM_SENDSYSTRAY                 9213
#endif /**/ /* DEFINEUNSUPPORTEDLSMSGS */
#define LM_SYSTRAY                     9214
#define LM_SYSTRAYREADY                9215

/** OBSOLETE ***
#define LM_ADDWINDOW                   9220
#define LM_REMOVEWINDOW                9221
#define LM_MINMAXWIN                   9222
#define LM_ACTIVEWIN                   9223
*** OBSOLETE **/

#define LM_RECYCLE                     9260

#ifdef /**/ DEFINEUNSUPPORTEDLSMSGS
#define LM_SHOWABOUT                   9261
#endif /**/ /* DEFINEUNSUPPORTEDLSMSGS */

#define LM_REGISTERMESSAGE             9263
#define LM_UNREGISTERMESSAGE           9264
#define LM_GETREVID                    9265
#define LM_UNLOADMODULE                9266
#define LM_RELOADMODULE                9267
#ifdef /**/ DEFINEUNSUPPORTEDLSMSGS
#define LM_REGISTERHOOKMESSAGE         9268
#define LM_UNREGISTERHOOKMESSAGE       9269

#define LM_SHADETOGGLE                 9300
#endif /**/ /* DEFINEUNSUPPORTEDLSMSGS */
#define LM_REFRESH                     9305

#ifdef /**/ DEFINEUNSUPPORTEDLSMSGS
#define LM_THREAD_BANGCOMMAND          9310
#define LM_THREADREADY                 9311
#define LM_THREADFINISHED              9312
#endif /**/ /* DEFINEUNSUPPORTEDLSMSGS */

// VWM messages
#ifdef /**/ DEFINEUNSUPPORTEDLSMSGS
#define LM_VWMUP                       9350
#define LM_VWMDOWN                     9351
#define LM_VWMLEFT                     9352
#define LM_VWMRIGHT                    9353
#define LM_VWMNAV                      9354
#define LM_SWITCHTON                   9355
#define LM_ISSTICKY                    9356
#define LM_STICK                       9357
#define LM_UNSTICK                     9358
#define LM_LISTDESKTOPS                9359
#define LM_DESKTOPINFO                 9360
#define LM_GETDESKTOPOF                9361
#endif /**/ /* DEFINEUNSUPPORTEDLSMSGS */

// core messages
/** OBSOLETE ***
*** Poor form! -reusing the same ID for LM_GETLSOBJECT,
*** even though LM_WINLIST was obsolete at the time.
*** Good thing they are both obsolete now.
#define LM_WINLIST                     9400
#define LM_GETLSOBJECT                 9400
#define LM_WINDOWLIST                  9401

#define LM_DATASTORE                   9410
#define LM_MESSAGEMANAGER              9411
*** OBSOLETE **/

#define LM_BANGCOMMAND                 9420

#ifdef /**/ DEFINEUNSUPPORTEDLSMSGS
#define LM_ADDBANGCOMMAND              9421
#define LM_REMOVEBANGCOMMAND           9422
#endif /**/ /* DEFINEUNSUPPORTEDLSMSGS */

// shell hook messages
#define LM_SHELL_HOOK                  (9500)
#define LM_WINDOWCREATED               (LM_SHELL_HOOK + 1)
#define LM_WINDOWDESTROYED             (LM_SHELL_HOOK + 2)
#define LM_ACTIVATESHELLWINDOW         (LM_SHELL_HOOK + 3)
#define LM_WINDOWACTIVATED             (LM_SHELL_HOOK + 4)
#define LM_GETMINRECT                  (LM_SHELL_HOOK + 5)
#define LM_REDRAW                      (LM_SHELL_HOOK + 6)
#define LM_TASKMAN                     (LM_SHELL_HOOK + 7)
//#define LM_LANGUAGE                    (LM_SHELL_HOOK + 8)
//#define LM_SYSMENU                     (LM_SHELL_HOOK + 9)
#define LM_ENDTASK                     (LM_SHELL_HOOK + 10)
//#define LM_ACCESSIBILITYSTATE          (LM_SHELL_HOOK + 11)
#define LM_APPCOMMAND                  (LM_SHELL_HOOK + 12)
#define LM_WINDOWREPLACED              (LM_SHELL_HOOK + 13)
#define LM_WINDOWREPLACING             (LM_SHELL_HOOK + 14)


#define MAX_BANGCOMMAND				64
#define MAX_BANGARGS				256
#define MAX_RCCOMMAND				64
#define MAX_LINE_LENGTH				4096
#define MAX_PATH_LENGTH				1024

typedef struct _LMBANGCOMMANDA
{
	DWORD cbSize;
	HWND  hWnd;
	CHAR  szCommand[MAX_BANGCOMMAND];
	CHAR  szArgs[MAX_BANGARGS];
}
LMBANGCOMMANDA, *PLMBANGCOMMANDA;

typedef struct _LMBANGCOMMANDW
{
	DWORD cbSize;
	HWND  hWnd;
	WCHAR szCommand[MAX_BANGCOMMAND];
	WCHAR szArgs[MAX_BANGARGS];
}
LMBANGCOMMANDW, *PLMBANGCOMMANDW;

#ifdef _UNICODE
#define LMBANGCOMMAND    LMBANGCOMMANDW
#define PLMBANGCOMMAND   PLMBANGCOMMANDW
#else // _UNICODE
#define LMBANGCOMMAND    LMBANGCOMMANDA
#define PLMBANGCOMMAND   PLMBANGCOMMANDA
#endif // _UNICODE


#endif /* _INC_LSMSGS */
